!
subroutine LA10(A, AF, T, Det, Error)
!  A      L  U
!         
!declaration
real, intent(in):: A(:,:)
real:: AF(:,:), Det
integer:: T(:), Error
real AA, WW, RN
double precision Sum
integer i, j, k, p, max, N
!begin
  N=size(A,1); RN=float(N)
  Det=1.0; Error=0
  if (loc(A)/=loc(AF)) AF=A
  do p=1, N-1
    if (p>1) then
      do i=p, N
        Sum=dble(AF(i,p))
        do k=1, p-1
          Sum=Sum-AF(i,k)*dble(AF(k,p))
        end do
        AF(i,p)=sngl(Sum)
      end do
    end if
    AA=abs(AF(p,p)); max=p
    do i=p+1, N
      if (AA<abs(AF(i,p))) then
        AA=abs(AF(i,p)); max=i
      end if
    end do
    if (RN+AA==RN) then
      Det=0.0; Error=65; return;
    end if
    if (max/=p) then
      do k=1, N
        AA=AF(max,k); AF(max,k)=AF(p,k); AF(p,k)=AA
      end do
      Det=-Det
    end if
    Det=Det*AF(p,p); T(p)=max
    do i=p+1, N
      AF(i,p)=AF(i,p)/AF(p,p)
    end do
    if (p>1) then
      do j=p+1, N
        Sum=dble(AF(p,j))
        do k=1, p-1
          Sum=Sum-AF(p,k)*dble(AF(k,j))
        end do
        AF(p,j)=sngl(Sum)
      end do
    end if
  end do
  Sum=dble(AF(N,N))
  do k=1, N-1
    Sum=Sum-AF(N,k)*dble(AF(k,N))
  end do
  AF(N,N)=sngl(Sum)
  Det=Det*sngl(Sum); T(N)=N
  return
end subroutine LA10
